import 'package:flutter/material.dart';
import 'package:namer_app/footer.dart';
import 'package:namer_app/header.dart';
import 'package:namer_app/service/addplatform_serv.dart';

class AddPlatformPage extends StatelessWidget {
  const AddPlatformPage({super.key});

  @override
  Widget build(BuildContext context) {
    var platname = TextEditingController();
    var projname = TextEditingController();
    return Scaffold(
      appBar: CustomAppbar(),
      backgroundColor: Colors.white,
      body: Column(
        mainAxisAlignment: MainAxisAlignment.spaceEvenly,
        children: [
          Center(
              child: Row(
            mainAxisAlignment: MainAxisAlignment.center,
            children: [
              Text(
                'ADD PLATFORM',
                style: TextStyle(color: Colors.black, fontSize: 48),
              ),
            ],
          )),
          Column(
            children: [
              Padding(
                padding: const EdgeInsets.all(8.0),
                child: SizedBox(
                  width: 396,
                  child: TextField(
                    decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        focusedBorder: OutlineInputBorder(
                            borderRadius: BorderRadius.all(Radius.circular(12)),
                            borderSide: BorderSide(color: Colors.black)),
                        enabledBorder: OutlineInputBorder(
                            borderRadius: BorderRadius.all(Radius.circular(12)),
                            borderSide: BorderSide(color: Colors.black)),
                        labelText: 'Enter Platform Name', //todo get data
                        labelStyle: TextStyle(color: Colors.black),
                        filled: true,
                        fillColor: Colors.white.withOpacity(0.25)),
                    cursorColor: Colors.black,
                    style: TextStyle(color: Colors.black),
                    controller: platname,
                  ),
                ),
              ),
              Padding(
                padding: const EdgeInsets.all(8.0),
                child: SizedBox(
                  width: 396,
                  child: TextField(
                    decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        focusedBorder: OutlineInputBorder(
                            borderRadius: BorderRadius.all(Radius.circular(12)),
                            borderSide: BorderSide(color: Colors.black)),
                        enabledBorder: OutlineInputBorder(
                            borderRadius: BorderRadius.all(Radius.circular(12)),
                            borderSide: BorderSide(color: Colors.black)),
                        labelText: 'Enter Project Name', //todo get data
                        labelStyle: TextStyle(color: Colors.black),
                        filled: true,
                        fillColor: Colors.white.withOpacity(0.25)),
                    cursorColor: Colors.black,
                    style: TextStyle(color: Colors.black),
                    controller: projname,
                  ),
                ),
              ),
              Padding(
                padding: const EdgeInsets.all(20.0),
                child: SizedBox(
                  width: 396,
                  height: 61,
                  child: ElevatedButton(
                    onPressed: () => addplatform(context, platname.text, projname.text), 
                    style: ElevatedButton.styleFrom(
                      backgroundColor: Colors.black, //todo putih lage
                      side: BorderSide(color: Colors.white),
                      shape: RoundedRectangleBorder(
                        borderRadius: BorderRadius.circular(12.0),
                      ),
                    ),
                    child: Text(
                      'Save',
                      style: TextStyle(color: Colors.white),
                    ),
                  ),
                ),
              ),
            ],
          ),
        ],
      ),
      bottomNavigationBar: Footer(),
    );
  }
}
